package nl.sbdeveloper.mctpaudio.api.maps;

import java.util.ArrayList;
import java.util.Random;

/* Copyright (C) McThemeParks - All Rights Reserved
 * Unauthorized copying of this file, via any medium is strictly prohibited
 * Proprietary and confidential
 * Written by Stijn Bannink <stijnbannink23@gmail.com>, July 2020
 */

/**
 * An {@link ArrayList} with shuffle support.
 *
 * @param <E> The type you want to store
 */
public class SongList<E> extends ArrayList<E> {
    public void shuffle() {
        Random random = new Random();

        for (int index = 0; index < this.size(); index++) {
            int secondIndex = random.nextInt(this.size());
            swap(index, secondIndex);
        }
    }

    public E getRandom() {
        Random random = new Random();

        return this.get(random.nextInt(this.size()));
    }

    private void swap(int firstIndex, int secondIndex) {
        E first = this.get(firstIndex);
        E second = this.get(secondIndex);

        this.set(secondIndex, first);
        this.set(firstIndex, second);
    }
}